# AVR timer calculator
# Calculates the Compare register values necessary to achieve a certain timer interrupt time.
# Programmed by jean-claude.feltes@education.lu

from Tkinter import *

# create main window
window=Tk()
window.title("AVR Timer Calculator")

# Calculate
def Calculate():
    
    # get values from Entries
    Prescale = int(p_entry.get())
    Crystal = float(c_entry.get())
    Int_time= float(t_entry.get())
    
    #Calculate
    Timer_freq_kHz = Crystal/Prescale * 1000
    Timer_T_us = 1/Timer_freq_kHz * 1000
    Max_Timer2 = Timer_T_us * 255
    Max_Timer1 = Timer_T_us * 65535
    Compare_Timer1 = int(round( Int_time / Timer_T_us))
    Compare_Timer2 =  int(round (Int_time / Timer_T_us))
    
    #possible values? resulting interrupt time
    if Compare_Timer1 > 65535:
        notpossible1 = "(not possible!)"
        Int_time1 = "-"
    else:
        notpossible1 = ""
        Int_time1 = str(Compare_Timer1 * Timer_T_us) + "us"
            
    if Compare_Timer2 > 255:
        notpossible2 = "(not possible!)"
        Int_time2 = "-"
    else:
        notpossible2 =""  
        Int_time2 = str(Compare_Timer2 * Timer_T_us) + " us"
    
    # Display
    t= "Crystal frequency: " + str( Crystal) + " MHz\n"
    t=t+ "Prescale: " + str(Prescale) + "\n" 
    t = t + "Timer frequency: " + str(Timer_freq_kHz) +  " kHz\n" 
    t=t+ "Timer period: " + str(Timer_T_us) + " us\n"
    t = t + "Max. Timer1: " + str(Max_Timer1) + "us\n"
    t = t + "Max. Timer2: " + str(Max_Timer2) + "us\n\n"
    t = t + "Compare value Timer1: " + str(Compare_Timer1) + "   " + notpossible1 +"\n"
    t = t + "Compare value Timer2: " + str(Compare_Timer2) + "   " + notpossible2 + "\n\n"
    t = t + "Resulting time Timer1: " + Int_time1  + "\n"
    t = t + "Resulting time Timer2: " + Int_time2  + "\n"
    text.insert("1.1",t)
    
#Crystal entry
Label(window, text="Crystal frequency [MHz]").grid(row=0, column=0)
c_entry=Entry(window)
c_entry.grid(row=0, column=1, pady=5)
c_entry.insert(2,"8")

#Prescale entry
Label(window, text="Prescale: 8 / 64 / 256 / 1024").grid(row=1, column=0)
p_entry=Entry(window)
p_entry.grid(row=1, column=1, pady=5)
p_entry.insert(2,"1024")

#Interrupt time entry
Label(window, text="Interrupt time [us]:").grid(row=2, column=0)
t_entry=Entry(window)
t_entry.grid(row=2, column=1, pady=5)
t_entry.insert(2,"1000000")

# text field
text= Text(window, width=50, height=13)
text.grid(row=3, columnspan=2, padx=10, pady=10)

# button Calculate
btnOK=Button(master=window, text="Calculate", command = Calculate)
btnOK.grid (row=4, column=0, pady=5 )

# Event handler
window.mainloop()


